// hostbyaddr.c
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>		/* for gettimeofday() */
#include <unistd.h>			/* for gettimeofday()  */
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

int main(int argc, const char **argv)
{
    u_long addr;
    struct hostent *hp;
	struct timeval t_inicial, t_final;
	float t_gethostbyaddr;
    char **p;

    if (argc != 2) {
        (void) printf("Uso: %s Endereco_IP\n", argv[0]);
        exit (1);
    }


	// inet_addr transforma uma string de ip (x.x.x.x) em um nmero binrio 
    if ((int)(addr = inet_addr(argv[1])) == -1) {
        (void) printf("Forma do Endereco_IP: a.b.c.d\n");
        exit (2);
    }

	gettimeofday( &t_inicial, NULL );
	// gethostbyaddr(const void *addr, int len, int type);
    hp = gethostbyaddr((char *)&addr, sizeof (addr), AF_INET);
	gettimeofday( &t_final, NULL );
	
	t_gethostbyaddr = (float)(t_final.tv_sec  - t_inicial.tv_sec);
	t_gethostbyaddr += (t_final.tv_usec - t_inicial.tv_usec)/(float)1000000;
	printf("Tempo gethostbyaddr(): %.10f sec\n", t_gethostbyaddr);
	fflush(stdout);
	
    if (hp == NULL) {
        (void) printf("No foram encontradas informaes sobre o hospedeiro %s\n", argv[1]);
        exit (3);
    }

	/*	struct hostent
		char    *h_name;        // official name of host 
		char    **h_aliases;    // alias list 
		int     h_addrtype;     // host address type 
		int     h_length;       // length of address 
		char    **h_addr_list;  // list of addresses 
	
	struct in_addr
		unsigned long s_addr;
	*/

    for (p = hp->h_addr_list; *p != 0; p++) {
        struct in_addr in;
        char **q;
		
        (void) memcpy(&in.s_addr, *p, sizeof (in.s_addr));
		(void) printf("%s\t%s", inet_ntoa(in), hp->h_name);
		
        for (q = hp->h_aliases; *q != 0; q++)
            (void) printf(" %s", *q);
        (void) putchar('\n');
    }
	
    exit (0);
}

